<?php
// script from emmanuel vanneau (phpMyAgenda)
// $Id: date.inc.php3, v2.0 2001/01/06 
/******************************************************************************
 * FUNCTIONS
 *****************************************************************************/

if(!isset($DATEINCLUDE)):
	$DATEINCLUDE = 1;

function print_add_date_form($idevent , $idplace) {
/* print a blank date form so we can add a new events */

	global $CFG,$ME;

	$frm["newmode"]     	  = "ins_date";
	$frm["nextstep"] 				= "";
	
	$time = time();	
	$frm["startday"]	     	= "";
	$frm["startmonth"]	    = "";
	$frm["startyear"]   	  = date("Y" , $time);
	$frm["starthour"]	    	= "";
	$frm["startmin"]  			= "";
	
	$frm["endday"]    			= "";
	$frm["endmonth"]		    = "";
	$frm["endyear"]    			= date("Y" , $time);
	$frm["endhour"]		    	= "";
	$frm["endmin"]    			= "";

	$frm["idevent"]					= $idevent;
	$frm["idplace"]					= $idplace;
	
	$frm["valid"] 					= 0;
	
	include("templates/date_form.php3");
}

function print_edit_date_form($iddate , $idplace = 0) {
/* edit date form */

	global $CFG,$ME;
	
	debug("Editing date ".$iddate);
	$qid = db_query("SELECT * FROM $CFG->table_date WHERE id = $iddate");
	$frm = db_fetch_array($qid);

	$frm["newmode"]     	  = "update_date";
	debug("start = ".$frm["start"]);
	explode_date($frm["start"] , $frm["startyear"] , $frm["startmonth"] , $frm["startday"] , $frm["starthour"] , $frm["startmin"]);
	explode_date($frm["end"] , $frm["endyear"] , $frm["endmonth"] , $frm["endday"] , $frm["endhour"] , $frm["endmin"]);

	$frm["idevent"]					= $frm["event"];
	if($idplace == 0)
				$frm["idplace"]		= $frm["place"];
	else	$frm["idplace"]		= $idplace;
	
	$frm["iddate"] = $iddate;
		
	include("templates/date_form.php3");
}


function insert_date($frm , $valid = 0)
{
	global $CFG;
	$qid = db_query("INSERT INTO $CFG->table_date
	       (id, start, end, event, place , valid)
	        VALUES ('', '$frm[start]', '$frm[end]','$frm[idevent]', '$frm[idplace]' , $valid)");
	$nDateID = db_insert_id();
	echo "<!-- date $nDateID inserted successfully -->";
	return $nDateID;
}

function update_date($id , $frm)
{
	global $CFG;
	$qid = db_query("UPDATE $CFG->table_date SET 
										start = '$frm[start]' , 
										end 	= '$frm[end]' , 
										event = '$frm[idevent]' , 
										place = '$frm[idplace]' 
									WHERE id = $id");
}

function delete_date($id)
{
	global $CFG;
	$qid = db_query("DELETE FROM $CFG->table_date WHERE id = $id");
}

function remove_nonvalid_dates()
{
	global $CFG;
 	db_query("DELETE FROM $CFG->table_date WHERE valid=0");
 	debug("removing non valid date");
}

function delete_date_from_event($idevent){
// remove all dates refering to $iddevent
	global $CFG;
	db_query("DELETE FROM $CFG->table_date WHERE event = $idevent");
}

function validate_date_form(&$frm , $mode)
{
	// validate date form
  global $CFG,$ME;
  debug("validating date form");
 	$validation 			= false;
 	$validation_step  = 0;
 	if(!checkdate($frm["startmonth"] , $frm["startday"] , $frm["startyear"]) ||
 		 !validate_date($frm["starthour"]  	, 0 , 23) ||
 		 !validate_date($frm["startmin"]  	, 0 , 59))
	{
		$validation 		= true;
	 	$validation_start  = 1;
	 	debug("error during validation on checkdate start");
	}
	
	format_date_end_as_date($frm);

 	if(!checkdate($frm["endmonth"] , $frm["endday"] , $frm["endyear"]) ||
 		 !validate_date($frm["endhour"]  	, 0 , 23) ||
 		 !validate_date($frm["endmin"]  	, 0 , 59))
	{
		$validation 		= true;
	 	$validation_end  = 3;
	 	debug("error during validation on checkdate end");
	}

 	if(1 == compare_date($frm["startmonth"] , $frm["startday"] , $frm["startyear"] , $frm["starthour"] , $frm["startmin"] ,
 											 $frm["endmonth"] , $frm["endday"] , $frm["endyear"] , $frm["endhour"] , $frm["endmin"]))
 	{
 		$validation = true;
 	 	$validation_end  = 2;
	 	debug("error during validation start<end");
	}
 	
 	if($validation)
 	{
 		$frm["newmode"] = $mode;
 		include("templates/date_form.php3");
		return false;
 	}
 	return true; 	  
}	

function validate_date($data , $min , $max)
{
	if(!isset($data))
		return false;
	if(empty($data))
		return false;
	if($data < $min)
		return false;
	if($data > $max)
		return false;
	return true;
}

function compare_date($datayear1 , $datamonth1 , $dataday1 , $datahour1 , $datamin1 ,
										  $datayear2 , $datamonth2 , $dataday2 , $datahour2 , $datamin2)
{
	if($datayear1 	== $datayear2 && 
		 $datamonth1 	== $datamonth2 && 
		 $dataday1 		== $dataday2 &&
		 $datahour1		== $datahour2 &&
		 $datamin1		== $datamin2)
		 return 0;
		 
	if($datayear1 < $datayear2)
		 return -1;

	if($datayear1 > $datayear2)
		 return 1;
		 
	if($datamonth1 < $datamonth2)
		 return -1;

	if($datamonth1 > $datamonth2)
		 return 1;
	
	if($dataday1 < $dataday2)
		 return -1;

	if($dataday1 > $dataday2)
		 return 1;
	
	if($datahour1 < $datahour2)
		 return -1;

	if($datahour1 > $datahour2)
		 return 1;

	if($datamin1 < $datamin2)
		 return -1;

	if($datamin1 > $datamin2)
		 return 1;
	
	return 0;
}

endif;
?>